<template>
    <div class="pump d-flex align-items-center">
        <slot></slot>
        <div :style="{ width: width, height: calculatedHeight }" class="position-relative">
            <div v-if="labelTop"
                 :style="{ 'font-size': fontSize }"
                 class="position-absolute center-x"
                 style="top: -30%">
                {{ labelTop }}
            </div>

            <div v-if="labelBottom"
                 :style="{ 'font-size': fontSize }"
                 class="position-absolute center-x"
                 style="bottom: -30%;">
                {{ labelBottom }}
            </div>

            <div v-if="labelRight"
                 :style="{ 'font-size': fontSize }"
                 class="position-absolute center-y"
                 style="left:90%">
                {{ labelRight }}
            </div>

            <div v-if="labelLeft"
                 :style="{ 'font-size': fontSize }"
                 class="position-absolute center-y"
                 style="right: 90%">
                {{ labelLeft }}
            </div>

            <svg :class="fillClass" class="pump"
                 height="100%"
                 viewBox="0 0 100 100"
                 width="100%"
                 xmlns="http://www.w3.org/2000/svg">
                <rect :class="{'stroke-default': !strokeColor}" :stroke="strokeColor ? strokeColor : null" height="20" stroke-width="3" width="50" x="1"
                      y="20"/>

                <circle :class="{'stroke-default': !strokeColor}" :stroke="strokeColor ? strokeColor : null" cx="50%"
                        cy="50%"
                        r="30%"
                        stroke-width="3"
                />
                <rect :class="{'stroke-default': !strokeColor}"
                      :stroke="strokeColor ? strokeColor : null" height="20" stroke-width="3" style="  transform-box: fill-box; transform-origin: center; transform: rotate(45deg);" width="50" x="50"
                      y="20"/>
            </svg>
        </div>
    </div>

</template>

<script>
export default {
    name: 'feed-pump-component',
    props: {
        labelTop: {
            type: String,
        },
        labelBottom: {
            type: String,
        },
        labelRight: {
            type: String,
        },
        labelLeft: {
            type: String,
        },
        width: {
            type: [Number, String],
            default: '4rem'
        },
        height: {
            type: [Number, String],
        },
        status: {
            type: String,
            default: 'on'
        },
        fontSize: {
            type: String,
            default: '1.2rem'
        },
        strokeColor: {
            type: String
        }
    },
    computed: {
        fillClass: function () {
            if (this.status === 'on') {
                return 'fill-on'
            }

            if (this.status === 'trip') {
                return 'fill-trip'
            }

            return 'fill-off'
        },
        calculatedHeight: function () {
            return this.width;
        }
    }
}
</script>
